<?php

if ( ! defined( 'ABSPATH' ) ) exit;

class GLSDKWC_admin_info_Message {
    private $_message;

    function __construct( $message ) {
        $this->_message = $message;
    }
	
	function success() {
		add_action( 'admin_notices', array( $this, 'render_success' ) );
	}
	
    function render_success() {
		?>
            <div class="notice notice-success is-dismissible">
                <p><strong><?php echo esc_html( $this->_message ); ?></strong></p>
            </div>
        <?php
    }
	
	function error() {
		add_action( 'admin_notices', array( $this, 'render_error' ) );
	}
	
    function render_error() {
		?>
            <div class="notice  notice-error is-dismissible">
                <p><strong><?php echo esc_html( $this->_message ); ?></strong></p>
            </div>
        <?php
    }
	
	function warning() {
		add_action( 'admin_notices', array( $this, 'render_warning' ) );
	}
	
    function render_warning() {
		?>
            <div class="notice  notice-warning is-dismissible">
                <p><strong><?php echo esc_html( $this->_message ); ?></strong></p>
            </div>
        <?php
    }
}

class gls_dk_wc_class_Settings {

	/**
	 * The single instance of WordPress_Plugin_Template_Settings.
	 * @var 	object
	 * @access  private
	 * @since 	1.0.0
	 */
	private static $_instance = null;

	/**
	 * The main plugin object.
	 * @var 	object
	 * @access  public
	 * @since 	1.0.0
	 */
	public $parent = null;

	/**
	 * Prefix for plugin settings.
	 * @var     string
	 * @access  public
	 * @since   1.0.0
	 */
	public $base = '';
	public $plugin_data;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $plugin_name    The string used to uniquely identify this plugin.
	 */
	protected $plugin_name;	

	/**
	 * Available settings for plugin.
	 * @var     array
	 * @access  public
	 * @since   1.0.0
	 */
	public $settings = array();

	public function __construct ( $parent ) {
		$this->parent = $parent;

		$this->base = $this->parent->get_base();
		$this->plugin_data = $this->parent->get_plugin_data();
		$this->plugin_name = $this->parent->get_plugin_name();
	}

	/**
	 * Initialise settings
	 * @return void
	 */
	public function init_settings () {
		$this->settings = $this->settings_fields();
		
		$wc_gls_testmode = get_option($this->base.$this->plugin_name."_".$this->plugin_data['get_gls_tab_txt'].'_wc_gls_testmode','on');
		if($wc_gls_testmode!='on'){	
		
			$gls_username = get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_username');
			if( ! $gls_username || $gls_username==""){
				$adm = new GLSDKWC_admin_info_Message( __("Please set Gls Username.", $this->plugin_name ) );
				$adm->error();
			}
			$gls_password= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_password');
			if( ! $gls_password || $gls_password==""){
				$adm = new GLSDKWC_admin_info_Message( __("Please set Gls password.", $this->plugin_name ) );
				$adm->error();
			}
			$gls_Customerid= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_Customerid');
			if( ! $gls_Customerid || $gls_Customerid==""){
				$adm = new GLSDKWC_admin_info_Message( __("Please set Customer id.", $this->plugin_name ) );
				$adm->error();
			}
			$gls_contactid= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_contactid');
			if( ! $gls_contactid || $gls_contactid==""){
				$adm = new GLSDKWC_admin_info_Message( __("Please set Contact id.", $this->plugin_name ) );
				$adm->error();
			}

			$wc_gls_AlternativeShipper= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper','');
			if( $wc_gls_AlternativeShipper == 'on' ){
				$wc_gls_AlternativeShipper_name= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_name');
				if( ! $wc_gls_AlternativeShipper_name || $wc_gls_AlternativeShipper_name==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper name.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_address= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_address');
				if( ! $wc_gls_AlternativeShipper_address || $wc_gls_AlternativeShipper_address==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper address", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_city= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_city');
				if( ! $wc_gls_AlternativeShipper_city || $wc_gls_AlternativeShipper_city==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper city.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_zipcode= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_zipcode');
				if( ! $wc_gls_AlternativeShipper_zipcode || $wc_gls_AlternativeShipper_zipcode==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper zipcode.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_glsAlternativeShipper_country= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_glsAlternativeShipper_country');
				if( ! $wc_glsAlternativeShipper_country || $wc_glsAlternativeShipper_country==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please AlternativeShipper country.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_contact= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_contact');
				if( ! $wc_gls_AlternativeShipper_contact || $wc_gls_AlternativeShipper_contact==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper contact.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_phone= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_phone');
				if( ! $wc_gls_AlternativeShipper_phone || $wc_gls_AlternativeShipper_phone==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper phone.", $this->plugin_name ) );
					$adm->error();
				}
				$wc_gls_AlternativeShipper_email= get_option($this->base.$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'].'_wc_gls_AlternativeShipper_email');
				if( ! $wc_gls_AlternativeShipper_email || $wc_gls_AlternativeShipper_email==""){
					$adm = new GLSDKWC_admin_info_Message( __("Please set AlternativeShipper email.", $this->plugin_name ) );
					$adm->error();
				}
			}			
		}
	}

	/**
	 * Add settings page to admin menu
	 * @return void
	 */
	public function add_menu_item () {		
		//Main menu 
		$page = add_menu_page(
			__( $this->plugin_name.' Settings', $this->plugin_name ) , 
			__( 'Gls WC Settings', $this->plugin_name ) ,  
			'manage_options', 
			$this->plugin_name . '_settings', 
			array( $this, 'settings_page')
		);
			 
		add_submenu_page(
			$this->plugin_name . '_settings', 
			__( 'Front Page Elements', $this->plugin_name ) ,  
			__( 'Plugin Settings', $this->plugin_name ) ,  
			'manage_options', 
			$this->plugin_name . '_settings', 
			array( $this, 'settings_page')
		); 
		
		add_submenu_page( 
			$this->plugin_name . '_settings', 
			__( 'FAQ page title', $this->plugin_name ) ,  
			__( 'FAQ menu label', $this->plugin_name ) ,  
			'manage_options', 
			__( 'theme-op-faq', $this->plugin_name ) ,  
			array( $this, 'wps_theme_func_faq')
		);			
	}

	function wps_theme_func_faq(){
			$html = '<div class="wrap bg-success"><div id="icon-options-general" class="icon32"><br></div><h2>FAQ</h2></div>';
			echo $html;
	}			

	/**
	 * Add settings link to plugin list table
	 * @param  array $links Existing links
	 * @return array 		Modified links
	 */
	public function add_settings_link ( $links ) {
		$settings_link = '<a href="options-general.php?page=' . $this->plugin_name . '_settings">' . __( 'Settings', $this->plugin_name ) . '</a>';
  		array_push( $links, $settings_link );
  		return $links;
	}

	/**
	 * Build settings fields
	 * @return array Fields to be displayed on settings page
	 */
	private function settings_fields () {
		$tab_name=$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_txt'];
		$settings[$tab_name] = array(
			'title'					=> __( 'GLS Settings', $this->plugin_name ),
			'description'			=> __( 'Configure the display of the available delivery options in checkout.', $this->plugin_name ),
			'fields'				=> array(
				array(
					'id' 			=> $tab_name.'_wc_support_options',
					'label'			=> __( 'Support options', $this->plugin_name ),
					'description'	=> __( 'Support from plugin developer.', $this->plugin_name ),
					'type'			=> 'support_options'
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_username',
					'label'			=> __( 'Gls Username' , $this->plugin_name ),
					'description'	=> __( 'Your username from Gls.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'text-center',
					'default'		=> '',
					'placeholder'	=> __( 'Set Gls Username', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_password',
					'label'			=> __( 'Gls Password' , $this->plugin_name ),
					'description'	=> __( 'Your password from Gls.', $this->plugin_name ),
					'type'			=> 'password',
					'class'			=> 'text-center',
					'default'		=> '',
					'placeholder'	=> __( 'password', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_customerid',
					'label'			=> __( 'Customer ID' , $this->plugin_name ),
					'description'	=> __( 'Customer ID from Gls.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'text-center',
					'default'		=> '',
					'placeholder'	=> __( 'Set Customer ID', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_contactid',
					'label'			=> __( 'Contact ID' , $this->plugin_name ),
					'description'	=> __( 'Contact ID from Gls.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'text-center',
					'default'		=> '',
					'placeholder'	=> __( 'Set Contact ID', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_Shipper_country',
					'label'			=> __( 'Shipper Country', $this->plugin_name ),
					'description'	=> __( 'Select Shipper Country.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'select',
					'options'		=> array(
								  'DK'	=> __( 'Denmark', $this->plugin_name )
								),
					'default'		=> 'DK'
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_testmode',
					'label'			=> __( 'Use Test mode', $this->plugin_name ),
					'description'	=> __( 'Use Test mode to get Gls labels', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'checkbox',
					'default'		=> 'on'
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_shipping_setup',
					'label'			=> __( 'Auto generate shippings settings', $this->plugin_name ),
					'description'	=> __( 'Generate one flad rate and one local pickup', $this->plugin_name ).'<br>'.__('The shipping methods can be changed, and renamed ', $this->plugin_name).sprintf(__('%shere%s', 'gls-woocommerce'), '<a target="_blank" href="' . admin_url('admin.php?page=wc-settings&tab=shipping') . '">', '</a>'),
					'class'			=> 'text-center',
					'type'			=> 'checkbox',
					'default'		=> 'on'
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper',
					'label'			=> __( 'Use Alternative Shipper', $this->plugin_name ),
					'description'	=> __( 'Using Alternative Shipper', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_name',
					'label'			=> __( 'Alternative Shipper Name' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Name.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Name', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_address',
					'label'			=> __( 'Alternative Shipper Address' , $this->plugin_name ),
					'class'			=> 'text-center',
					'description'	=> __( 'Alternative Shipper Address.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Address', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_city',
					'label'			=> __( 'Alternative Shipper City' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper City.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper City', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_zipcode',
					'label'			=> __( 'Alternative Shipper Zipcode' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Zipcode.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Zipcode', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_glsAlternativeShipper_country',
					'label'			=> __( 'Alternative Shipper Country', $this->plugin_name ),
					'description'	=> __( 'Select Alternative Shipper Country.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'select',
					'options'		=> array(
								  'DK'	=> __( 'Denmark', $this->plugin_name )
								),
					'default'		=> 'DK'
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_contact',
					'label'			=> __( 'Alternative Shipper Contact' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Contact. Contact person', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Contact.', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_phone',
					'label'			=> __( 'Alternative Shipper Phone' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Phone.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Phone', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_mobile',
					'label'			=> __( 'Alternative Shipper Mobile' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Mobile.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Mobile', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_AlternativeShipper_email',
					'label'			=> __( 'Alternative Shipper Email' , $this->plugin_name ),
					'description'	=> __( 'Alternative Shipper Email.', $this->plugin_name ),
					'class'			=> 'text-center',
					'type'			=> 'text',
					'default'		=> '',
					'placeholder'	=> __( 'Set Alternative Shipper Email', $this->plugin_name )
				),
			)
		);
		
		$tab_name=$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_shop_time'];
		$settings[$tab_name] = array(
			'title'					=> __( 'Opening hours', $this->plugin_name ),
			'description'			=> __( 'Business hours are the hours during the day in which business is commonly conducted. For your company', $this->plugin_name ),
			'fields'				=> array(
				array(
					'id' 			=> $tab_name.'_Sunday_start',
					'label'			=> __( 'Open that day Sunday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_Sunday_end',
					'label'			=> __( 'Closed that day Sunday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_Monday_start',
					'label'			=> __( 'Open that day Monday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '8:00'
				),
				array(
					'id' 			=> $tab_name.'_Monday_end',
					'label'			=> __( 'Closed that day Monday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '16:00'
				),
				array(
					'id' 			=> $tab_name.'_Tuesday_start',
					'label'			=> __( 'Open that day Tuesday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '8:00'
				),
				array(
					'id' 			=> $tab_name.'_Tuesday_end',
					'label'			=> __( 'Closed that day Tuesday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '16:00'
				),
				array(
					'id' 			=> $tab_name.'_Wednesday_start',
					'label'			=> __( 'Open that day Wednesday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '8:00'
				),
				array(
					'id' 			=> $tab_name.'_Wednesday_end',
					'label'			=> __( 'Closed that day Wednesday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '16:00'
				),
				array(
					'id' 			=> $tab_name.'_Thursday_start',
					'label'			=> __( 'Open that day Thursday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '8:00'
				),
				array(
					'id' 			=> $tab_name.'_Thursday_end',
					'label'			=> __( 'Closed that day Thursday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '16:00'
				),
				array(
					'id' 			=> $tab_name.'_Friday_start',
					'label'			=> __( 'Open that day Friday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '8:00'
				),
				array(
					'id' 			=> $tab_name.'_Friday_end',
					'label'			=> __( 'Closed that day Friday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> '16:00'
				),
				array(
					'id' 			=> $tab_name.'_Saturday_start',
					'label'			=> __( 'Open that day Saturday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_Saturday_end',
					'label'			=> __( 'Closed that day Saturday' , $this->plugin_name ),
					'description'	=> __( 'Leave blank if closed that day.', $this->plugin_name ),
					'type'			=> 'text',
					'class'			=> 'time_day text-center',
					'default'		=> ''
				),
			)
		);		
			
		$tab_name=$this->plugin_name.'_'.$this->plugin_data['get_gls_tab_checkout'];
		$settings[$tab_name] = array(
			'title'					=> __( 'GLS Woocommerce Checkout page', $this->plugin_name ),
			'description'			=> __( 'Settings for GLS Woocommerce Checkout page.', $this->plugin_name ),
			'fields'				=> array(
				array(
					'id' 			=> $tab_name.'_wc_gls_add_tracking_info_to_completed_order_email',
					'label'			=> __( 'Add tracking info to completed order email', $this->plugin_name ),
					'description'	=> __( 'Tracking info to completed order email', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> 'on'
				),/*
				array(
					'id' 			=> $tab_name.'_hide_local_pickup_shipping',
					'label'			=> __( 'Hide local pickup shipping', $this->plugin_name ),
					'description'	=> __( 'This hides local pickup shipping' ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),*/
				array(
					'id' 			=> $tab_name.'_wc_gls_checkout_remove_all',
					'label'			=> __( 'Remove all Gls from Woocommerce Checkout', $this->plugin_name ),
					'description'	=> __( 'Disable GLS on Wommerce Checkout page', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_checkout_remove_pickup',
					'label'			=> __( 'Remove Pick up at Parcel Shop from Woocommerce Checkout', $this->plugin_name ),
					'description'	=> __( 'Disable Pick up at Parcel Shop on Wommerce Checkout page', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_checkout_remove_business_delevery',
					'label'			=> __( 'Remove Business delevery from Woocommerce Checkout', $this->plugin_name ),
					'description'	=> __( 'Disable Business delevery on Wommerce Checkout page', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_checkout_remove_home_delevery',
					'label'			=> __( 'Remove Home delevery from Woocommerce Checkout', $this->plugin_name ),
					'description'	=> __( 'Disable Home delevery on Wommerce Checkout page', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_checkout_remove_pickup_at_firm',
					'label'			=> __( 'Remove Pickup at firm from Woocommerce Checkout', $this->plugin_name ),
					'description'	=> __( 'Disable Pickup at firm on Wommerce Checkout page', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_headline_checkout',
					'label'			=> __( 'Text Headline GLS Checkout' , $this->plugin_name ),
					'description'	=> __( 'Text Headline for GLS Checkout.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'Select shipping method', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
				array(
					'id' 			=> $tab_name.'_wc_headline_post_shopnumber',
					'label'			=> __( 'Text Headline Post or Parcel shop number' , $this->plugin_name ),
					'description'	=> __( 'Text Headline for Post or Parcel shop number.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'Alternative shops. Enter Post or Parcel shop number', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
				array(
					'id' 			=> $tab_name.'_wc_pickup_parcelshop',
					'label'			=> __( 'Text GLS. Pick up at parcelshop' , $this->plugin_name ),
					'description'	=> __( 'Text for GLS. Pick up at parcelshop.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'GLS. Pick up at parcelshop', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
				array(
					'id' 			=> $tab_name.'_wc_business_delevery',
					'label'			=> __( 'Text Delivery to business address' , $this->plugin_name ),
					'description'	=> __( 'Text for Delivery to business address.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'GLS. Delivery to business address', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
				array(
					'id' 			=> $tab_name.'_wc_profession_text_block',
					'label'			=> __( 'A Text Block Delivery to business address' , $this->plugin_name ),
					'description'	=> __( 'Text area for Delivery to business address.', $this->plugin_name ),
					'type'			=> 'textarea',
					'class'			=> 'w-25',
					'default'		=> __( 'GLS Delivery to business address<br>
										Weekdays between 7-16.</br>
										GLS delivers for the goods delivery together with the company other packages.</br>', $this->plugin_name ),
					'placeholder'	=> __( 'GLS Delivery to business address<br> 
										Weekdays between 7-16.</br>
										GLS delivers for the goods delivery together with the company other packages.</br>', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_home_delivery',
					'label'			=> __( 'Text Home delivery' , $this->plugin_name ),
					'description'	=> __( 'Text for Home delivery.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'Home delivery', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
				array(
					'id' 			=> $tab_name.'_wc_home_delevery_text_block',
					'label'			=> __( 'A Text Block Home delevery' , $this->plugin_name ),
					'description'	=> __( 'Text area for Home delevery.', $this->plugin_name ),
					'type'			=> 'textarea',
					'class'			=> 'w-25',
					'default'		=> __( '
									GLS Home Delivery - Delivery to your address<br> 
									Weekdays between 7-16.<br> 
									If GLS does not reach anyone at the address, you will receive information about what happens to your package.<br> 
									This information is either a note in your mailbox or an email / text message.<br> 
									There are two options:<br> 
									1. GLS runs the package to a parcel shop nearby.<br> 
									You bring package no. and ID and retrieve the package when it suits you.<br> 
									2. GLS takes the package back to GLS Depot.<br> 
									You must then tell how you want the delivery<br> 
									- Do you want to pick up at the depot ?.<br> 
									-Should the package be redirected to your workplace ?.<br> 
									-Should GLS deliver to the original address ?.<br> 
									<br> 
									In either case, you have 10 business days to respond.<br> 
									The GLS then returns the package to the sender.<br> ', $this->plugin_name ),
					'placeholder'	=> __( '
									GLS Home Delivery - Delivery to your address<br> 
									Weekdays between 7-16.<br> 
									If GLS does not reach anyone at the address, you will receive information about what happens to your package.<br> 
									This information is either a note in your mailbox or an email / text message.<br> 
									There are two options:<br> 
									1. GLS runs the package to a parcel shop nearby.<br> 
									You bring package no. and ID and retrieve the package when it suits you.<br> 
									2. GLS takes the package back to GLS Depot.<br> 
									You must then tell how you want the delivery<br> 
									- Do you want to pick up at the depot ?.<br> 
									-Should the package be redirected to your workplace ?.<br> 
									-Should GLS deliver to the original address ?.<br> 
									<br> 
									In either case, you have 10 business days to respond.<br> 
									The GLS then returns the package to the sender.<br> ', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_pickup_at_videx',
					'label'			=> __( 'Text Pick up at our company address' , $this->plugin_name ),
					'description'	=> __( 'Text for Pick up at our company address.', $this->plugin_name ),
					'type'			=> 'text',
					'default'		=> __( 'Pick up at our company address', $this->plugin_name ),
					'class'			=> 'w-25 text-center'
				),
			)
		);

		$tab_name=$this->plugin_name.'_'.$this->plugin_data['get_gls_diverse_txt'];
		$settings[$tab_name] = array(
			'title'					=> __( 'GLS miscellaneous page', $this->plugin_name ),
			'description'			=> __( 'Settings for GLS miscellaneous page.', $this->plugin_name ),
			'fields'				=> array(
				array(
					'id' 			=> $tab_name.'_wc_weight_extra',
					'label'			=> __( 'Extra weight' , $this->plugin_name ),
					'description'	=> __( 'Extra weight, such as packaging e.t.c. in (kg)', $this->plugin_name ),
					'class'         => 'text-center',
					'type'			=> 'number',
					'default'		=> '0.2',
					'placeholder'	=> __( '0.2', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_processing_time',
					'label'			=> __( 'Processing Time' , $this->plugin_name ),
					'description'	=> __( 'The time (in days) it takes to process and package an order before it\'s shipped.', $this->plugin_name ),
					'type'			=> 'number',
					'class'         => 'text-center',
					'default'		=> '',
					'placeholder'	=> __( '0', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_gls_auto_print',
					'label'			=> __( 'Auto Print Label', $this->plugin_name ),
					'description'	=> __( 'Print label using standard(default printer, no print dialog box if selected)', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> ''
				),
				array(
					'id' 			=> $tab_name.'_wc_display_shops',
					'label'			=> __( 'No. of Shops to Display' , $this->plugin_name ),
					'description'	=> __( 'Number of ParcelShops to display in the ShopDelivery-tab in checkout.', $this->plugin_name ),
					'class'         => 'text-center',
					'type'			=> 'number',
					'default'		=> '5',
					'placeholder'	=> __( '5', $this->plugin_name )
				),
				array(
					'id' 			=> $tab_name.'_wc_disable_shipping_calc_on_cart',
					'label'			=> __( 'Hide shipping calculation on cart page', $this->plugin_name ),
					'description'	=> __( 'Disable shipping calculation on cart page)', $this->plugin_name ),
					'type'			=> 'checkbox',
					'default'		=> 'on'
				),
			)
		);
		
		$settings = apply_filters( $this->plugin_name . '_settings_fields', $settings );

		return $settings;
	}


	/**
	 * Register plugin settings
	 * @return void
	 */
	public function register_settings () {
		if ( is_array( $this->settings ) ) {

			// Check posted/selected tab
			$current_section = '';
			if ( isset( $_POST['tab'] ) && $_POST['tab'] ) {
				$current_section = sanitize_text_field( $_POST['tab'] );
			} else {
				if ( isset( $_GET['tab'] ) && $_GET['tab'] ) {
					$current_section = sanitize_text_field( $_GET['tab'] );
				}
			}
			
			foreach ( $this->settings as $section => $data ) {

				if ( $current_section && $current_section != $section ) continue;

				// Add section to page
				add_settings_section( $section, $data['title'], array( $this, 'settings_section' ), $this->plugin_name . '_settings' );

				foreach ( $data['fields'] as $field ) {

					// Validation callback for field
					$validation = '';
					if ( isset( $field['callback'] ) ) {
						$validation = $field['callback'];
					}

					// Register field
					$option_name = $this->base . $field['id'];
					register_setting( $this->plugin_name . '_settings', $option_name, $validation );

					// Add field to page
					add_settings_field( $field['id'], $field['label'], array( $this->parent->admin, 'display_field' ), $this->plugin_name . '_settings', $section, array( 'field' => $field, 'prefix' => $this->base ) );
				}

				if ( ! $current_section ) break;
			}
		}
	}

	public function settings_section ( $section ) {
		$html = '<p> ' . $this->settings[ $section['id'] ]['description'] . '</p>' . "\n";
		echo $html;
	}

	/**
	 * Load settings page content
	 * @return void
	 */
	public function settings_page () {

		// Build page HTML
		$html = '<div class="wrap" id="' . $this->plugin_name . '_settings">' . "\n";
			$html .= '<h2>' . __( 'Plugin Settings' , $this->plugin_name ) . '</h2>' . "\n";

			$tab = '';
			if ( isset( $_GET['tab'] ) && $_GET['tab'] ) {
				$tab .= sanitize_text_field( $_GET['tab'] );
			}

			// Show page tabs
			if ( is_array( $this->settings ) && 1 < count( $this->settings ) ) {

				$html .= '<h2 class="nav-tab-wrapper">' . "\n";

				$c = 0;
				foreach ( $this->settings as $section => $data ) {

					// Set tab class
					$class = 'nav-tab';
					if ( ! isset( $_GET['tab'] ) ) {
						if ( 0 == $c ) {
							$class .= ' nav-tab-active';
						}
					} else {
						if ( isset( $_GET['tab'] ) && $section == $_GET['tab'] ) {
							$class .= ' nav-tab-active';
						}
					}

					// Set tab link
					$tab_link = add_query_arg( array( 'tab' => $section ) );
					if ( isset( $_GET['settings-updated'] ) ) {
						$tab_link = remove_query_arg( 'settings-updated', $tab_link );
					}

					// Output tab
					$html .= '<a href="' . $tab_link . '" class="' . esc_attr( $class ) . '">' . esc_html( $data['title'] ) . '</a>' . "\n";

					++$c;
				}

				$html .= '</h2>' . "\n";
			}

			$html .= '<form method="post" action="options.php" enctype="multipart/form-data">' . "\n";

				// Get settings fields
				ob_start();
				settings_fields( $this->plugin_name . '_settings' );
				do_settings_sections( $this->plugin_name . '_settings' );
				$html .= ob_get_clean();

				$html .= '<p class="submit">' . "\n";
					$html .= '<input type="hidden" name="tab" value="' . esc_attr( $tab ) . '" />' . "\n";
					$html .= '<input name="Submit" type="submit" class="button-primary" value="' . esc_attr( __( 'Save Settings' , $this->plugin_name ) ) . '" />' . "\n";
				$html .= '</p>' . "\n";
			$html .= '</form>' . "\n";
		$html .= '</div>' . "\n";

		echo $html;
	}

	public function get_plugin_name() {
		return $this->plugin_name;
	}
	
	/**
	 * Main WordPress_Plugin_Template_Settings Instance
	 *
	 * Ensures only one instance of WordPress_Plugin_Template_Settings is loaded or can be loaded.
	 *
	 * @since 1.0.0
	 * @static
	 * @see WordPress_Plugin_Template()
	 * @return Main WordPress_Plugin_Template_Settings instance
	 */
	public static function instance ( $parent ) {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self( $parent );
		}
		return self::$_instance;
	} // End instance()

	/**
	 * Cloning is forbidden.
	 *
	 * @since 1.0.0
	 */
	public function __clone () {
		_doing_it_wrong( __FUNCTION__, __( 'Cheatin&#8217; huh?' ), $this->parent->_version );
	} // End __clone()

	/**
	 * Unserializing instances of this class is forbidden.
	 *
	 * @since 1.0.0
	 */
	public function __wakeup () {
		_doing_it_wrong( __FUNCTION__, __( 'Cheatin&#8217; huh?' ), $this->parent->_version );
	} // End __wakeup()

}