<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       https://blohm.com
 * @since      1.0.0
 *
 * @package    gls_dk_wc_class
 * @subpackage gls_dk_wc_class/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    gls_dk_wc_class
 * @subpackage gls_dk_wc_class/includes
 * @author     Poul Werner Blohm <werner@blohm.com>
 */
class gls_dk_wc_class_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'gls_dk_wc',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
